/* Generated By:JavaCC: Do not edit this line. RDScript.java */
package controller.script;

// import java.io.PrintStream;
import java.io.StringReader;

import controller.Model;

@SuppressWarnings("all")
public class RDScript implements Runnable, RDScriptConstants {

	private Thread t;
	private Model model;
	private String text;
	private boolean loopAll = false;
	private long timer = 0;
	private int colStart = 0;
	private boolean pause = false;

	public static RDScript init(Model model, String text) {

		// generate Stream from String
		StringReader sr = new StringReader(text);
		// instantiate Parser Class
		RDScript parser = new RDScript(sr);
		// pass the Model object
		parser.setModel(model);
		// pass the Stream
		parser.setText(text);
		// create new Thread with the Parser
		Thread t = new Thread(parser);
		// pass the Thread
		parser.setThread(t);
		// parser.startThread();
		return parser;
	}

	public void setModel(Model model) {
		this.model = model;
	}

	public void setThread(Thread t) {
		this.t = t;
	}

	public void setText(String text) {
		this.text = text;
	}

	public void startThread() {
		pause = false;
		if (t.isAlive()) {
			t.resume();
		} else {
			t.start();
		}
	}

	public void suspendThread() {
		pause = true;
		// t.suspend();
		model.log("PAUSE");
	}

	public void stopThread() {
		t.stop();
	}

	public void run() {
		do {
			try {
				parseAndExecute();
				ReInit(new StringReader(text));
				t.sleep(10);
			} catch (ParseException e) {
				model.log(e + "");
			} catch (InterruptedException e) {
				model.log(e + "");
			}
		} while (loopAll);
		model.setScriptRunning(false);
		model.setParser(null);
	}

	// Grammar starts here
	final public void parseAndExecute() throws ParseException, InterruptedException {
		String s;
		label_1: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
				case COIL:
				case SEND:
				case WAIT:
				case START:
				case STOP:
				case ENGINE:
				case LOOP:
					;
					break;
				default:
					jj_la1[0] = jj_gen;
					break label_1;
			}
			s = Statement();
			if (s.length() > 0)
				model.log(s);
			if (pause)
				t.suspend();
			/* System.out.println(s); */

		}
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 0:
				jj_consume_token(0);
				break;
			case EXIT:
				jj_consume_token(EXIT);
				break;
			default:
				jj_la1[1] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
		}
	}

	final public String Statement() throws ParseException, InterruptedException {
		String s = "";
		String filename;
		int i, j, factor;
		long dur;
		int start, end;
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case COIL:
				jj_consume_token(COIL);
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
					case ON:
						jj_consume_token(ON);
						model.setCoilEnabled(true);
						break;
					case OFF:
						jj_consume_token(OFF);
						model.setCoilEnabled(false);
						break;
					default:
						jj_la1[2] = jj_gen;
						jj_consume_token(-1);
						throw new ParseException();
				}
				{
					if (true)
						return "";
				}
				break;
			case SEND:
				jj_consume_token(SEND);
				colStart = 0;
				dur = 0;
				start = -1;
				end = -1;
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
					case IMAGE:
						jj_consume_token(IMAGE);
						filename = String();
						switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
							case RANGE:
								jj_consume_token(RANGE);
								start = Number();
								jj_consume_token(HYPHEN);
								end = Number();
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case DURATION:
										jj_consume_token(DURATION);
										dur = Number();
										break;
									default:
										jj_la1[3] = jj_gen;
										;
								}
								// no % in name ...
								if (filename.indexOf("%") == -1) {
									{
										if (true)
											return "image doesn't contain '%'";
									}
								}

								for (int k = start; k <= end; k++) {
									long sTime = System.currentTimeMillis();
									s = filename.replaceFirst("%", String.valueOf(k)).replaceAll("\"", "");
									model.createImage(s);
									model.sendImage();
									while ((System.currentTimeMillis() - sTime) < dur)
										t.sleep(1);
									if (pause)
										t.suspend();
								}
								{
									if (true)
										return "";
								}
								break;
							case ROTATE:
								jj_consume_token(ROTATE);
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case LEFT:
										jj_consume_token(LEFT);
										factor = 1;
										break;
									case RIGHT:
										jj_consume_token(RIGHT);
										factor = -1;
										break;
									default:
										jj_la1[4] = jj_gen;
										jj_consume_token(-1);
										throw new ParseException();
								}
								i = Number();
								jj_consume_token(TIMES);
								j = Number();
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case DURATION:
										jj_consume_token(DURATION);
										dur = Number();
										break;
									default:
										jj_la1[5] = jj_gen;
										;
								}
								s = filename.substring(1, filename.length() - 1);
								model.createImage(s);

								while (j-- > 0) {
									long sTime = System.currentTimeMillis();
									model.sendImage(colStart);
									colStart += factor * i;
									while ((System.currentTimeMillis() - sTime) < dur)
										t.sleep(1);
									if (pause)
										t.suspend();
								}
								{
									if (true)
										return "";
								}
								break;
							default:
								jj_la1[7] = jj_gen;
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case DURATION:
										jj_consume_token(DURATION);
										dur = Number();
										break;
									default:
										jj_la1[6] = jj_gen;
										;
								}
								long sTime = System.currentTimeMillis();
								s = filename.substring(1, filename.length() - 1);
								model.createImage(s);
								model.sendImage();
								while ((System.currentTimeMillis() - sTime) < dur)
									t.sleep(1);
								if (pause)
									t.suspend();

								{
									if (true)
										return "";
								}
						}
						break;
					case TEXT:
						jj_consume_token(TEXT);
						s = String();
						switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
							case ROTATE:
								jj_consume_token(ROTATE);
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case LEFT:
										jj_consume_token(LEFT);
										factor = 1;
										break;
									case RIGHT:
										jj_consume_token(RIGHT);
										factor = -1;
										break;
									default:
										jj_la1[8] = jj_gen;
										jj_consume_token(-1);
										throw new ParseException();
								}
								i = Number();
								jj_consume_token(TIMES);
								j = Number();
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case DURATION:
										jj_consume_token(DURATION);
										dur = Number();
										break;
									default:
										jj_la1[9] = jj_gen;
										;
								}
								model.getEnterTextField().setText(s.substring(1, s.length() - 1));
								model.createImage(model.getEnterTextField());

								while (j-- > 0) {
									long sTime = System.currentTimeMillis();
									model.sendImage(colStart);
									colStart += factor * i;
									while ((System.currentTimeMillis() - sTime) < dur)
										t.sleep(1);
									if (pause)
										t.suspend();
								}
								{
									if (true)
										return "";
								}
								break;
							default:
								jj_la1[11] = jj_gen;
								switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
									case DURATION:
										jj_consume_token(DURATION);
										dur = Number();
										break;
									default:
										jj_la1[10] = jj_gen;
										;
								}
								model.getEnterTextField().setText(s.substring(1, s.length() - 1));
								model.createImage(model.getEnterTextField());

								long sTime = System.currentTimeMillis();
								model.sendImage();
								while ((System.currentTimeMillis() - sTime) < dur)
									t.sleep(1);
								if (pause)
									t.suspend();

								{
									if (true)
										return "";
								}
						}
						break;
					default:
						jj_la1[12] = jj_gen;
						jj_consume_token(-1);
						throw new ParseException();
				}
				break;
			case START:
				jj_consume_token(START);
				jj_consume_token(TIMER);
				timer = System.currentTimeMillis();
				{
					if (true)
						return "timer started.";
				}
				break;
			case STOP:
				jj_consume_token(STOP);
				jj_consume_token(TIMER);
				if (timer == 0) {
					if (true)
						return "timer wasn't started.";
				}
				dur = System.currentTimeMillis() - timer;
				timer = 0;
				{
					if (true)
						return "timer stopped at " + dur + " msec.";
				}
				break;
			case WAIT:
				jj_consume_token(WAIT);
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
					case NUMBER:
						i = Number();
						switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
							case SEC:
								jj_consume_token(SEC);
								t.sleep(i * 1000);
								{
									if (true)
										return "";
								}
								break;
							default:
								jj_la1[13] = jj_gen;
								;
						}
						switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
							case MSEC:
								jj_consume_token(MSEC);
								break;
							default:
								jj_la1[14] = jj_gen;
								;
						}
						t.sleep(i);
						{
							if (true)
								return "";
						}
						break;
					case UNTIL:
						jj_consume_token(UNTIL);
						jj_consume_token(TIMER);
						jj_consume_token(EQUALS);
						i = Number();
						while ((System.currentTimeMillis() - timer) < i) {
							t.sleep(1);
						}
						{
							if (true)
								return "";
						}
						break;
					default:
						jj_la1[15] = jj_gen;
						jj_consume_token(-1);
						throw new ParseException();
				}
				break;
			case ENGINE:
				jj_consume_token(ENGINE);
				i = Number();
				model.getPowerSlider().setValue(i);
				{
					if (true)
						return "";
				}
				break;
			case LOOP:
				jj_consume_token(LOOP);
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
					case ON:
						jj_consume_token(ON);
						loopAll = true;
						{
							if (true)
								return "";
						}
						break;
					case OFF:
						jj_consume_token(OFF);
						loopAll = false;
						{
							if (true)
								return "";
						}
						break;
					default:
						jj_la1[16] = jj_gen;
						jj_consume_token(-1);
						throw new ParseException();
				}
				break;
			default:
				jj_la1[17] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
		}
		throw new Error("Missing return statement in function");
	}

	final public String String() throws ParseException {
		Token t;
		t = jj_consume_token(STRING);
		{
			if (true)
				return t.image;
		}
		throw new Error("Missing return statement in function");
	}

	final public int Number() throws ParseException {
		Token t;
		t = jj_consume_token(NUMBER);
		{
			if (true)
				return Integer.parseInt(t.image);
		}
		throw new Error("Missing return statement in function");
	}

	public RDScriptTokenManager token_source;
	SimpleCharStream jj_input_stream;
	public Token token, jj_nt;
	private int jj_ntk;
	private int jj_gen;
	final private int[] jj_la1 = new int[18];
	static private int[] jj_la1_0;
	static private int[] jj_la1_1;
	static {
		jj_la1_0();
		jj_la1_1();
	}

	private static void jj_la1_0() {
		jj_la1_0 = new int[] { 0x300e6000, 0x1001, 0xc00, 0x40000000, 0xc00000, 0x40000000, 0x40000000, 0x80200000, 0xc00000, 0x40000000, 0x40000000, 0x200000,
				0x18000, 0x8000000, 0x4000000, 0x2000000, 0xc00, 0x300e6000, };
	}

	private static void jj_la1_1() {
		jj_la1_1 = new int[] { 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, };
	}

	public RDScript(java.io.InputStream stream) {
		jj_input_stream = new SimpleCharStream(stream, 1, 1);
		token_source = new RDScriptTokenManager(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	public void ReInit(java.io.InputStream stream) {
		jj_input_stream.ReInit(stream, 1, 1);
		token_source.ReInit(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	public RDScript(java.io.Reader stream) {
		jj_input_stream = new SimpleCharStream(stream, 1, 1);
		token_source = new RDScriptTokenManager(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	public void ReInit(java.io.Reader stream) {
		jj_input_stream.ReInit(stream, 1, 1);
		token_source.ReInit(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	public RDScript(RDScriptTokenManager tm) {
		token_source = tm;
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	public void ReInit(RDScriptTokenManager tm) {
		token_source = tm;
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 18; i++)
			jj_la1[i] = -1;
	}

	final private Token jj_consume_token(int kind) throws ParseException {
		Token oldToken;
		if ((oldToken = token).next != null)
			token = token.next;
		else
			token = token.next = token_source.getNextToken();
		jj_ntk = -1;
		if (token.kind == kind) {
			jj_gen++;
			return token;
		}
		token = oldToken;
		jj_kind = kind;
		throw generateParseException();
	}

	final public Token getNextToken() {
		if (token.next != null)
			token = token.next;
		else
			token = token.next = token_source.getNextToken();
		jj_ntk = -1;
		jj_gen++;
		return token;
	}

	final public Token getToken(int index) {
		Token t = token;
		for (int i = 0; i < index; i++) {
			if (t.next != null)
				t = t.next;
			else
				t = t.next = token_source.getNextToken();
		}
		return t;
	}

	final private int jj_ntk() {
		if ((jj_nt = token.next) == null)
			return (jj_ntk = (token.next = token_source.getNextToken()).kind);
		else
			return (jj_ntk = jj_nt.kind);
	}

	private java.util.Vector jj_expentries = new java.util.Vector();
	private int[] jj_expentry;
	private int jj_kind = -1;

	public ParseException generateParseException() {
		jj_expentries.removeAllElements();
		boolean[] la1tokens = new boolean[47];
		for (int i = 0; i < 47; i++) {
			la1tokens[i] = false;
		}
		if (jj_kind >= 0) {
			la1tokens[jj_kind] = true;
			jj_kind = -1;
		}
		for (int i = 0; i < 18; i++) {
			if (jj_la1[i] == jj_gen) {
				for (int j = 0; j < 32; j++) {
					if ((jj_la1_0[i] & (1 << j)) != 0) {
						la1tokens[j] = true;
					}
					if ((jj_la1_1[i] & (1 << j)) != 0) {
						la1tokens[32 + j] = true;
					}
				}
			}
		}
		for (int i = 0; i < 47; i++) {
			if (la1tokens[i]) {
				jj_expentry = new int[1];
				jj_expentry[0] = i;
				jj_expentries.addElement(jj_expentry);
			}
		}
		int[][] exptokseq = new int[jj_expentries.size()][];
		for (int i = 0; i < jj_expentries.size(); i++) {
			exptokseq[i] = (int[]) jj_expentries.elementAt(i);
		}
		return new ParseException(token, exptokseq, tokenImage);
	}

	final public void enable_tracing() {
	}

	final public void disable_tracing() {
	}

}
